
$regfile = "89s2051.dat"
$crystal = 12000000


                                          '12 MHz crystal

'Avtomaticheskoe vkluchenie sveta


Set P3.0                                                      'out
Set P3.1                                                      '2sec


Dim Oldtaho As Byte
Dim Time As Byte
Dim Sektime As Byte
Dim Taho As Byte
Dim Fl As Byte
Dim Count As Byte
Dim Count10 As Byte

Taho = 255
Oldtaho = 255
Time = 0
Sektime = 0

Count = 0
Count10 = 0

On Int1 Int1_int                                              'Initialise the INT1 Interrupt
Rem On Int0 Int0_int Nosave     'Initialise the INT0 Interrupt
Rem Use The Nosave Option When You Dont Want The Internal Registers To Be Saved/restored In
Rem The Interrupt Routine


Config Timer0 = Timer , Gate = Internal , Mode = 2
'Timer0 = counter : timer0 operates as a counter
'Gate = Internal  : no external gate control
'Mode = 2

On Timer0 Timer_0_int
Load Timer0 , 100                                             'when the timer reaches 100 an interrupt will occur

Enable Interrupts                                             'enable the use of interrupts
Enable Timer0                                                 'enable the timer
Enable Int1                                                   'enable the interrupt


Priority Set Int1                                             'set INT1 to the highest priority level (INT1 has by default the highest prio)
Set Tcon.2                                                    'trigger INT1 by falling edge.
'Intfl = 0

Rem Setting Of Priority
'Priority Set Timer0                       'highest priority



Start Timer0



   Do

   Wait 1

   Loop

End


Rem The Interrupt Handler For The Timer0 Interrupt
Timer_0_int:

   'Stop Timer0

   Incr Count
   If Count < 10 Then
      Goto Endint
   End If
   Count = 0

   If Taho < 250 Then
     Incr Taho
   Else
      Taho = 255
      Oldtaho = 255
   End If

   Incr Count10
   If Count10 < 10 Then
      Goto Endint
   End If
   Count10 = 0


   Incr Sektime
   'If Sektime < 100 Then
   If Sektime < 50 Then
      Goto Endint
   End If
   Sektime = 0

                                                 '1 cek
   If P3.1 = 1 Then
      Reset P3.1
   Else
      Set P3.1
   End If



   If Oldtaho > 38 Then
       If Time > 0 Then
         Decr Time
       End If
       If Time < 6 Then
         Set P3.0
         Time = 0
       End If
       Goto Endint
   End If

   If Time < 10 Then
      Incr Time
   End If

   If Time = 10 Then
      Reset P3.0
   End If

Endint:

'Start Timer0


Return


Rem The Interrupt Handler For The Int0 Interrupt
Int1_int:
      Oldtaho = Taho
      Taho = 0


Return